-- 藏宝阁主界面
checkRequire("Lua_EquipmentTreasurePanel"); -- 装备寻宝
checkRequire("Lua_RunesTreasurePanel"); -- 灵纹寻宝
checkRequire("Lua_PeakTreasurePanel"); -- 巅峰寻宝
checkRequire("Lua_SupremacyTreasurePanel"); -- 至尊寻宝
checkRequire("Lua_ApotheosizeTreasurePanel"); -- 封神寻宝
Lua_TreasureWindow = class("Lua_TreasureWindow", Lua_SpecialFullSizeTabLeftWindow);
function Lua_TreasureWindow:ctor()
	self.list = Array();
	self.list:add({name = LanUtil.getValue(121431), openId = 10078, eventIds = {11170, 11172, 21170}, clickRemoveEvent = {21170}, panel = Lua_EquipmentTreasurePanel, titleAltas = "titleName_altas_1", titleSprite = "cangbaoge"});
	self.list:add({name = LanUtil.getValue(121432), openId = 10079, eventIds = {11171}, panel = Lua_RunesTreasurePanel, titleAltas = "titleName_altas_1", titleSprite = "cangbaoge"});
	self.list:add({name = LanUtil.getValue(121435), openId = 10153, eventIds = {11191, 11172}, panel = Lua_PeakTreasurePanel, titleAltas = "titleName_altas_1", titleSprite = "cangbaoge"});
	self.list:add({name = LanUtil.getValue(121439), openId = 10169, eventIds = {11192, 11172}, panel = Lua_SupremacyTreasurePanel, titleAltas = "titleName_altas_1", titleSprite = "cangbaoge"});
	self.list:add({name = LanUtil.getValue(121445), openId = 10200, eventIds = {11193, 11172}, panel = Lua_ApotheosizeTreasurePanel, titleAltas = "titleName_altas_1", titleSprite = "cangbaoge"});    
	
	self:superCall("ctor", self.list, "treasure_atlas", "ui_treasure_btn_01", "ui_treasure_btn_02", Vector3(-10, -5, 0), Vector3(-10, -5, 0));
	self.windowName = "Lua_TreasureWindow";
	self.bgPath = "/images/recharge/ui_chongzhi_bg_07.png";
	self.isSetIndex = false; -- 不默认选择第一个
end

function Lua_TreasureWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	local index = 1;
	for i = 1, self.tabList:getSize() do
		if self.list[DataCenter.treasureData.treasureSortId].openId == self.tabList[i].openId then
			index = i;
			break;
		end
	end
	
	self:addLuaEvent("TREASURE_REDDOT_POS", self, self.setRedDotPos);
	Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasurePanelInfo();

	self.btnList:setSelected(index, true);
end

-- 更新红点位置
function Lua_TreasureWindow:setRedDotPos(openId)
	for i = 1, self.tabList:getSize() do
		self.btnList.pageArr[i]:setRedDotPos(openId == self.tabList[i].openId and 102 or 81, 33);
	end
end

function Lua_TreasureWindow:showWin(param)
	self:superCall("showWin", param);
	
	if type(param) == "number" then
		self.btnList:setSelected(param, true);
	elseif type(param) == "table" and param.openIdx ~= nil then
		self.btnList:setSelected(param.openIdx, true);
	end
end 

function Lua_TreasureWindow:dispose()
	DataCenter.treasureData.bEnableEquipmentDraw = true;
	DataCenter.treasureData.bEnableRunesDraw = true;
	DataCenter.treasureData.bEnablePeakDraw = true;
	Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sCloseTreasureWin();

	self:superCall("dispose");
end