-- 宝物抽奖结算界面
checkRequire("Lua_TreasureResultWindow");
Lua_EquipmentTreasureResultWindow = class("Lua_EquipmentTreasureResultWindow", Lua_TreasureResultWindow);
function Lua_EquipmentTreasureResultWindow:ctor()
    self:superCall("ctor");
    self.bShowRuneChips = false;
    self.itemWidth = 130;
    self.windowName = "Lua_EquipmentTreasureResultWindow";
end

function Lua_EquipmentTreasureResultWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self:addLuaEvent("rTreasureEquipmentDraw", self, self.onTreasureEquipmentDraw);
end

-- 抽奖返回
function Lua_EquipmentTreasureResultWindow:onTreasureEquipmentDraw(msg)
	self.drawType = msg.draw_type; -- 抽奖类型 0一次 1十次 2五十次
    if self.drawType == 1 then -- 十次
        self.againBtn.label = LanUtil.getValue(121433);
    elseif self.drawType == 0 then
        self.againBtn.label = LanUtil.getValue(121409);
    else
        self.againBtn.label = LanUtil.getValue(121434);
    end

    local list = msg.item_list;	-- 获得的道具列表
    local len = #list;
    if msg.draw_type == 2 then
        local arr = Array();
        for i = 1, len do 
            arr:add(list[i]);
        end
        if self.dragList == nil then
            self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 850, 280));
            self.dragList:setLocation(80, -5, 0);
            self.dragList:setListCell(Lua_TreasureDragItem, 143, 130, 5);
        end
        self.dragList:setLuaArrayData(arr, false);
    else
        local arr = Array();
        for i = 1, len do 
            local to = Lua_ToolVo.createToolVo(list[i].id);
            to:fromServer(list[i]);
            to.packType = Lua_PackTypeDefine.EQUIP;
            to.bShowQualityEff = true;
            arr:add(to);
        end
        self:setShowResultData(arr);
        for i = 1, self.rewardsArr:getSize() do
            self.rewardsArr[i].itemName.pivot = UIWidget.Pivot.Top;
            self.rewardsArr[i].itemName.overflowMethod = UILabel.Overflow.ResizeHeight;
            self.rewardsArr[i].itemName:SetDimensions(122, 30);
            self.rewardsArr[i].itemName:setLocation(0, -50);
        end
    end
end

function Lua_EquipmentTreasureResultWindow:onAgainBtnClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.show(LanUtil.getValue(121419));
        return;
    end
    self.clickTime = getTime();
    
    if self.drawType == nil then
        self:hide();
        return;
    end

    local costId = DataCenter.treasureUtil.equipDrawCostId;
    local ownNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costId);
    local costNum;

    if self.drawType == 1 then -- 十次
       costNum = DataCenter.treasureUtil.equipDrawTenCostNum
    elseif self.drawType == 0 then
       costNum = DataCenter.treasureUtil.equipDrawOneCostNum;
    else
       costNum =DataCenter.treasureUtil.equipDrawFiftyCostNum
    end
    
    local needBuyNum = costNum - ownNum;
    if needBuyNum > 0 then
        local vo = Lua_ToolVo.new(costId);
        if vo ~= nil then
            local str = "";
            self.costGoldNum = vo.goldPrice * needBuyNum;
            if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.costGoldNum then
                str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(self.costGoldNum).."[-]";
                self.bEnoughGold = false;
            else
                str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(self.costGoldNum).."[-]";
                self.bEnoughGold = true;
            end

            if DataCenter.neverTip:getNeverValue("Lua_EquipmentTreasurePanel") == true then
                if self.bEnoughGold == false then
                    OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121427), vo.colorName));
                else
                    Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureEquipmentDraw(self.drawType);
                end
                return;
            end

            local tipData = {};
            tipData.des = LanUtil.formateStr(LanUtil.getValue(121426), vo.colorName, str, tostring(needBuyNum));  
            tipData.neverTip = "Lua_EquipmentTreasurePanel";
            tipData.owner = self;
            tipData.type = 1;
            tipData.subFun = self.onSureFun;   --确定
            Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
        end
    else
        Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureEquipmentDraw(self.drawType);
    end
end

function Lua_EquipmentTreasureResultWindow:onSureFun()
    if self.bEnoughGold == true then
        Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureEquipmentDraw(self.drawType);
    else
        DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGoldNum, true, true);
    end
end

function Lua_EquipmentTreasureResultWindow:dispose()
    self.drawType = nil; 
    if self.dragList ~= nil then
        self.dragList:dispose()
        self.dragList = nil;
    end
    self:superCall("dispose");
end










Lua_TreasureDragItem = class("Lua_TreasureDragItem", Lua_ListCell);
function Lua_TreasureDragItem:ctor(p)
    self:superCall("ctor",p);
end

function Lua_TreasureDragItem:buildShowItem()
    self:superCall("buildShowItem");
    if self.itemImage == nil then
        self.itemImage = Lua_ToolImage.new(self.content);
        self.itemImage:setLocation(19,23,0)
        self.itemImage:setDepth(10);
    end
    if self.itemName == nil then
        self.itemName = UICreate.createLabel(self.content, "", 16, -25, 122, 30, 24);
        self.itemName:setDepth(3);
        self.itemName.pivot = UIWidget.Pivot.Top;
        self.itemName.overflowMethod = UILabel.Overflow.ResizeHeight
    end
end

function Lua_TreasureDragItem:setData(data)
    self.data = data;

    local tvo = Lua_ToolVo.createToolVo(data.id);
    tvo:fromServer(data);
    tvo.packType = Lua_PackTypeDefine.EQUIP;
    self.itemImage.data = tvo;
    self.itemName.text = tvo.colorName;
end

function Lua_TreasureDragItem:checkOutBound(showRect)
    if self.data == nil then
        self.inViewEffect = false;
        return;
    end

    local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 10, 100,60);
    if showRect:containeRect(rect) == true then
        self.inViewEffect = true;
    else
        self.inViewEffect = false;
    end
    self:updateEffectState();
end

function Lua_TreasureDragItem:updateEffectState()
    if self.inViewEffect == true then
        if self.itemImage.qualityEff == nil then
            self.itemImage:showQualityEff(true);
        end
    else
        if self.itemImage.qualityEff ~= nil then
            self.itemImage:showQualityEff(false);
        end
    end
end

function Lua_TreasureDragItem:dispose()
    self:superCall("dispose");
end