-- 积分商城
Lua_TreasureJifenMallWindow = class("Lua_TreasureJifenMallWindow", Lua_Window)
function Lua_TreasureJifenMallWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TreasureJifenMallWindow";
	self.skinName = "TreasureJifenMallWindow_skin";
	self.isClickClose = false;
end

function Lua_TreasureJifenMallWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.exchangeList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 880, 470));
	self.exchangeList:setLocation(0, -26, 0);
	self.exchangeList:setListCell(Lua_TreasureExchangeItem, 108, 440, 2);

	self:addLuaEvent("rTreasureJifenUpdate", self, self.onTreasureJifenUpdate);
	self:addLuaEvent("rTreasureEquipmentDraw", self, self.onTreasureEquipmentDraw);
	self:addLuaEvent("rTreasurePeakDraw", self, self.onTreasureRunesDraw);
	self:addLuaEvent("rSupremacyDraw", self, self.onTreasureSupremacyDraw);
	self:addLuaEvent("rApotheosizeDraw", self, self.onTreasurerApotheosizeDrawDraw);
end

function Lua_TreasureJifenMallWindow:showWin(param)
	self.drawType = param;
	if self.drawType == DataCenter.treasureData.equipmentDrawType then
		self.exchangeList:setLuaArrayData(DataCenter.treasureUtil:getExchangeData(1), false);
	elseif self.drawType == DataCenter.treasureData.peakDrawType then
		self.exchangeList:setLuaArrayData(DataCenter.treasureUtil:getExchangeData(2), false);
	elseif self.drawType == DataCenter.treasureData.supremacyDrawType then
		self.exchangeList:setLuaArrayData(DataCenter.treasureUtil:getExchangeData(3), false);
	elseif self.drawType == DataCenter.treasureData.apotheosizeDrawType then
		self.exchangeList:setLuaArrayData(DataCenter.treasureUtil:getExchangeData(4), false);
	end
end

-- 抽奖返回
function Lua_TreasureJifenMallWindow:onTreasureEquipmentDraw(msg)
	self:updateJifen();
end

-- 兑换返回
function Lua_TreasureJifenMallWindow:onTreasureJifenUpdate()
	self:updateJifen();
end

-- 巅峰抽奖返回
function Lua_TreasureJifenMallWindow:onTreasureRunesDraw(msg)
	self:updateJifen();
end

-- 至尊抽奖返回
function Lua_TreasureJifenMallWindow:onTreasureSupremacyDraw(msg)
	self:updateJifen();
end

-- 至尊抽奖返回
function Lua_TreasureJifenMallWindow:onTreasurerApotheosizeDrawDraw(msg)
	self:updateJifen();
end

-- 积分更新，刷新可兑换
function Lua_TreasureJifenMallWindow:updateJifen()
	if self.exchangeList ~= nil then
		local arr = self.exchangeList.showList;
		for i = 1, arr:getSize() do 
			arr[i]:updateCost();
		end

		arr = self.exchangeList.hideList;
		for i = 1, arr:getSize() do 
			arr[i]:updateCost();
		end
	end
end

function Lua_TreasureJifenMallWindow:dispose()
	if self.exchangeList ~= nil then
		self.exchangeList:dispose()
		self.exchangeList = nil;
	end
	self.drawType = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TreasureExchangeItem = class("Lua_TreasureExchangeItem", Lua_ListCell);
function Lua_TreasureExchangeItem:ctor(p)
	self:superCall("ctor", p, "TreasureExchangeItem_skin");
end

function Lua_TreasureExchangeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemName.text = "";
	self.jifenNumTxt.text = "";

	self.toolImg = Lua_ToolImage.new(self.content);
	self.toolImg:setDepth(1);
	self.toolImg:setLocation(-168, 0, 0);

	self.exchangeBtn:addClickFuntion(self, self.onExchangeBtnClick);
end

function Lua_TreasureExchangeItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local arr = data.reward;
	if arr ~= nil then
		local vo = Lua_ToolVo.new(arr[1]);
		if vo ~= nil then
			vo.bind = arr[2];
			vo.count = arr[3];
			vo.star = arr[4];
			vo.packType = 999;
			self.itemName.text = vo.colorName;
		end
		self.toolImg.data = vo;
	end
	self:updateCost();
end

-- 刷新消耗
function Lua_TreasureExchangeItem:updateCost()
	local costNum = self._data.cost;
	local ownNum = DataCenter.treasureData.jifenNum;
	local str;
	if costNum > ownNum then
		self.bEnougCost = false;
		str = "["..Lua_ColorDefine.RED_STR.."]"..costNum.."[-]";
	else
		self.bEnougCost = true;
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..costNum.."[-]";
	end
	self.jifenNumTxt.text = LanUtil.formateStr(LanUtil.getValue(121412), str);
end

function Lua_TreasureExchangeItem:onExchangeBtnClick(go)
	if self._data == nil then
		return;
	end

	-- 判断是否满足兑换
	if self.bEnougCost == nil or self.bEnougCost == false then
		OperateAlert.show(LanUtil.getValue(121425));
		return;
	end
	Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureMallExchange(self._data.id, self._data.drawType);
end

function Lua_TreasureExchangeItem:dispose()
	if self.toolImg ~= nil then
		self.toolImg:dispose();
		self.toolImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end