checkRequire("Lua_TreasureIconSign");
checkRequire("Lua_TreasureRecordsItem");
Lua_PeakTreasurePanel = class("Lua_PeakTreasurePanel", Lua_DisplayObject);
function Lua_PeakTreasurePanel:ctor(p)
	self:superCall("ctor", p, "TreasurePeak_skin");
end

function Lua_PeakTreasurePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.oneBtn.label = LanUtil.getValue(121442);
	self.tenBtn.label = LanUtil.getValue(121443);
	self.fiftyBtn.label = LanUtil.getValue(121444);

	-- 显示展示道具
	local arr = DataCenter.treasureUtil:getEquipmentTreasureShow(DataCenter.treasureData.peakDrawType);
	local cell;
	local posX = {-318, -202, -87, 29, 144, 144, 29, -87, -202, -318, -257, -85, 84};
	local posY = {218, 218, 218, 218, 218, -67, -67, -67, -67, -67, 76, 76, 76};
	local scaleArr = {0.87, 0.87, 0.87, 0.87, 0.87, 0.87, 0.87, 0.87, 0.87, 0.87, 1.1, 1.1, 1.1};
	local bgUrlArr = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1};

	local obj;
	local sign;
	local signInfo = DataCenter.treasureUtil.peakShowSignInfo;
	for i = 1, arr:getSize() do
		cell = Lua_PeakTreasureIcon.new(self.content);
		cell.content.name = "Lua_PeakTreasureIcon"..i;
		cell:setDepth(4);
		cell:setScale(scaleArr[i], scaleArr[i]);
		cell:setShowData(arr[i]);
		cell:showBgType(bgUrlArr[i]);
		cell:showEffect(i == 11 or i == 12 or i == 13);
		cell:setLocation(posX[i], posY[i], 0);

		obj = signInfo[tonumber(arr[i].index)];
		if obj ~= nil and obj[3] ~= nil and obj[3] ~= "" then
			sign = Lua_TreasureIconSign.new(self.content);
			sign:setSignInfo(obj);
			sign:setLocation(posX[i] - cell.toolImg.defaultWidth * scaleArr[i] / 4,
				posY[i] + cell.toolImg.defaultHeight * scaleArr[i] / 4, 0);
		end
	end

	self.recordsDragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, -225, 310, 470));
	self.recordsDragContainer:setLocation(445, 205, 0);
	self.recordsDragContainer.uiPanel.depth = 3000;

	local costId = DataCenter.treasureUtil.peakDrawCostId;
	if costId ~= nil then
		self.costVo = Lua_ToolVo.new(costId);
		self.icon_left:setAltas(self.costVo.atlas, self.costVo.referenceId);
		self.icon_center:setAltas(self.costVo.atlas, self.costVo.referenceId);
		self.icon_right:setAltas(self.costVo.atlas, self.costVo.referenceId);
	end

	self.helpImg:addClickFuntion(self, self.onHelpClick);
	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.tenBtn:addClickFuntion(self, self.onTenBtnClick);
	self.fiftyBtn:addClickFuntion(self, self.onFiftyBtnClick);
	self.storeBtn:addClickFuntion(self, self.onStoreBtnClick);
	self.mallBtn:addClickFuntion(self, self.onMallBtnClick);
	self.icon_left:addClickFuntion(self, self.onCostIconClick);
	self.icon_center:addClickFuntion(self, self.onCostIconClick);
	self.icon_right:addClickFuntion(self, self.onCostIconClick); -- 50连抽

	Lua_MsgUtil.callFunc("TREASURE_REDDOT_POS", 10153);

	self:updateCost();
	self:onRedDotUpdate();
	self:onTreasurePanelInfo();

	self:addLuaEvent("rTreasurePanelInfo", self, self.onTreasurePanelInfo);
	self:addLuaEvent("rPeakTreasureDrawRecords", self, self.updateServerRecords);
	self:addLuaEvent("rTreasurePeakDraw", self, self.updateIntegral);
	self:addLuaEvent("rTreasureJifenUpdate", self, self.updateIntegral);
	self:addLuaEvent("PACK_UPDATE", self, self.onPackDataUpdate);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.onRedDotUpdate);
	Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureDrawRecords(DataCenter.treasureData.peakDrawType);
end

-- 更新消耗
function Lua_PeakTreasurePanel:updateCost()
	local costId = DataCenter.treasureUtil.peakDrawCostId;
	local ownNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costId);
	local costOneNum = DataCenter.treasureUtil.peakDrawOneCostNum;
	local str;

	--一次
	if ownNum >= costOneNum then
		self.bEnoughOneCost = true;
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..ownNum.."/"..costOneNum.."[-]";
	else
		self.bEnoughOneCost = false;
		str = "["..Lua_ColorDefine.RED_STR.."]"..ownNum.."/"..costOneNum.."[-]";
	end
	self.oneBtnRedDot:setEnable(self.bEnoughOneCost);
	self.costNum_one.text = LanUtil.formateStr(LanUtil.getValue(121401), str);

	--十次
	local costTenNum = DataCenter.treasureUtil.peakDrawTenCostNum;
	if ownNum >= costTenNum then
		self.bEnoughTenCost = true;
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..ownNum.."/"..costTenNum.."[-]";
	else
		self.bEnoughTenCost = false;
		str = "["..Lua_ColorDefine.RED_STR.."]"..ownNum.."/"..costTenNum.."[-]";
	end
	self.tenBtnRedDot:setEnable(self.bEnoughTenCost);
	self.costNum_ten.text = LanUtil.formateStr(LanUtil.getValue(121401), str);

	--五十次
	local costFiftyNum = DataCenter.treasureUtil.peakDrawFiftyCostNum;
	if ownNum >= costFiftyNum then
		self.bEnoughFiftyCost = true;
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..ownNum.."/"..costFiftyNum.."[-]";
	else
		self.bEnoughFiftyCost = false;
		str = "["..Lua_ColorDefine.RED_STR.."]"..ownNum.."/"..costFiftyNum.."[-]";
	end
	self.fiftyBtnRedDot:setEnable(self.bEnoughFiftyCost);
	self.costNum_fifty.text = LanUtil.formateStr(LanUtil.getValue(121401), str);

	self:updateCostIconPos();
end

function Lua_PeakTreasurePanel:updateCostIconPos()
	local oneCostSize = self.costNum_one:lastPrintedSize(self.costNum_one.text);
	local tenCostSize = self.costNum_ten:lastPrintedSize(self.costNum_ten.text);
	local fiftyCostSize = self.costNum_fifty:lastPrintedSize(self.costNum_fifty.text);
	self.icon_left:setLocation(oneCostSize.x / 2 - 24, 0);
	self.icon_center:setLocation(tenCostSize.x / 2 - 24, 0);
	self.icon_right:setLocation(fiftyCostSize.x / 2 - 24, 0);
end

-- 红点更新
function Lua_PeakTreasurePanel:onRedDotUpdate(obj)
	if obj == nil or obj.evenId == 11172 then
		self.packRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11172));
	end
end

-- 面板信息
function Lua_PeakTreasurePanel:onTreasurePanelInfo(list)
	self:updateIntegral();
	self:updateServerRecords(list);
end

-- 更新积分
function Lua_PeakTreasurePanel:updateIntegral()
	self.jifenNumTxt.text = LanUtil.formateStr(LanUtil.getValue(121402), tostring(DataCenter.treasureData.jifenNum));
	self:checkMallRedDot();
end

-- 判断积分商城是否有可兑换
function Lua_PeakTreasurePanel:checkMallRedDot()
end

-- 更新全服记录
function Lua_PeakTreasurePanel:updateServerRecords(list)
	if list ~= nil then
		local arr = Array();
		for i = 1, #list do
			if list[i].proto_item ~= nil and list[i].proto_item.id > 0 then
				arr:add({data = list[i], drawType = DataCenter.treasureData.peakDrawType});
			end
		end

		local item;
		local nowLen = self.recordsDragContainer.childrenList:getSize();
		local len = arr:getSize();
		for i = 1, len do
	        item = self.recordsDragContainer.childrenList[i] or Lua_TreasureRecordsItem.new(self.recordsDragContainer.sub);
	        if self.recordsDragContainer.childrenList:getItem(i) == nil then
	           self.recordsDragContainer:addSubContainer(item, false);
	        end
	    end
		for i = len + 1, nowLen do
		    self.recordsDragContainer.childrenList[i]:setEnable(false);
		end

		len = arr:getSize();
		for i = 1, len do 
			self.recordsDragContainer.childrenList[i]:setData(arr[i]);
		end
		self.recordsDragContainer:updateChildPos();
	end
end

-- 背包更新
function Lua_PeakTreasurePanel:onPackDataUpdate(packType)
	if packType == Lua_PackData.BAG_PACK then
		self:updateCost();
	elseif packType == Lua_PackData.TREASURE_SOTRE then -- 临时仓库更新
		self:checkStoreRedDot();
	end
end

-- 判断临时仓库是否有可领取道具
function Lua_PeakTreasurePanel:checkStoreRedDot()
end

function Lua_PeakTreasurePanel:onHelpClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, LanUtil.getValue(121437));
end

function Lua_PeakTreasurePanel:onOneBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.bEnoughOneCost == false then
		if self.costVo ~= nil then
			self.drawType = 0;
			local ownNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(DataCenter.treasureUtil.peakDrawCostId);
			local costNum = DataCenter.treasureUtil.peakDrawOneCostNum;
			self:onBuy(costNum - ownNum);
		end
		return;
	end
	Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasurePeakDraw(0);
end

function Lua_PeakTreasurePanel:onTenBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.bEnoughTenCost == false then
		if self.costVo ~= nil then
			self.drawType = 1;
			local ownNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(DataCenter.treasureUtil.peakDrawCostId);
			local costNum = DataCenter.treasureUtil.peakDrawTenCostNum;
			self:onBuy(costNum - ownNum);
		end
		return;
	end
	Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasurePeakDraw(1);
end

function Lua_PeakTreasurePanel:onFiftyBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	if self.bEnoughFiftyCost == false then
		if self.costVo ~= nil then
			self.drawType = 2;
			local ownNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(DataCenter.treasureUtil.peakDrawCostId);
			local costNum = DataCenter.treasureUtil.peakDrawFiftyCostNum;
			self:onBuy(costNum - ownNum);
		end
		return;
	end
	Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasurePeakDraw(2);
end

function Lua_PeakTreasurePanel:onBuy(needBuyNum)
	if needBuyNum > 0 then
		self.costGoldNum = self.costVo.goldPrice * needBuyNum;
		local str;
		if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.costGoldNum then
			str = "["..Lua_ColorDefine.RED_STR.."]"..self.costGoldNum.."[-]";
			self.bEnoughGold = false;
		else
			str = "["..Lua_ColorDefine.GREEN_STR.."]"..self.costGoldNum.."[-]";
			self.bEnoughGold = true;
		end

		if DataCenter.neverTip:getNeverValue("Lua_PeakTreasurePanel") then
			if self.bEnoughGold == false then
				OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121427), self.costVo.colorName));
			else
				Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasurePeakDraw(self.drawType);
			end
			return;
		end
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, neverTip = "Lua_PeakTreasurePanel",
			des = LanUtil.formateStr(LanUtil.getValue(121426), self.costVo.colorName, str, tostring(needBuyNum)),
			type = 1, subFun = self.onSureFun});
	end
end

function Lua_PeakTreasurePanel:onSureFun()
	if self.bEnoughGold then
		Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasurePeakDraw(self.drawType);
	else
		DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGoldNum, true, true);
	end
end

function Lua_PeakTreasurePanel:onStoreBtnClick(go)
	Lua_WindowUtil.openWin("Lua_TreasurePackWindow");
end

function Lua_PeakTreasurePanel:onMallBtnClick(go)
	Lua_WindowUtil.openWin("Lua_TreasureJifenMallWindow", nil, DataCenter.treasureData.peakDrawType);
end

function Lua_PeakTreasurePanel:onCostIconClick(go)
	if self.costVo ~= nil then
		Lua_PackUtil.showItemInfo(self.costVo);
	end
end

function Lua_PeakTreasurePanel:dispose()
	if self.recordsDragContainer ~= nil then
		self.recordsDragContainer:dispose();
		self.recordsDragContainer = nil;
	end
	self.drawType = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_PeakTreasureIcon = class("Lua_PeakTreasureIcon", Lua_DisplayObject);
function Lua_PeakTreasureIcon:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PeakTreasureIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, "", "", 3, -3, 100, 104);
	self.bg:setDepth(4);

	self.toolImg = Lua_ToolImage.new(self.content);
	self.toolImg:setDepth(5);
end

function Lua_PeakTreasureIcon:setShowData(vo)
	self.toolImg.data = vo;
end

function Lua_PeakTreasureIcon:showBgType(bgType)
	if bgType == 1 then
		self.bg:setAltas("treasure_atlas", "ui_treasure_widget_02");
		self.bg:setLocation(1, -2);
	else
		self.bg:setAltas("treasure_atlas", "ui_treasure_widget_01");
		self.bg:setLocation(3, -3);
	end
end

function Lua_PeakTreasureIcon:showEffect(val)
	if val then
		self.showEff = UICreate.createUIEffect(self.content, "/effects/scsEffects/treasure_show", "treasure_show", 0, 0);
		self.showEff:setLoop(true);
		self.showEff:SetRenderQueue(self.bg, 1, 2, false);
	end
end

function Lua_PeakTreasureIcon:dispose()
	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	if self.toolImg ~= nil then
		self.toolImg:dispose();
		self.toolImg = nil;
	end
	if self.showEff ~= nil then
		self.showEff:dispose();
		self.showEff = nil;
	end

	self:superCall("dispose");
end