-- 全服记录
Lua_TreasureRecordsItem = class("Lua_TreasureRecordsItem", Lua_DragContainerItem);
function Lua_TreasureRecordsItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TreasureRecordsItem:buildShowItem()
	self:superCall("buildShowItem");

	self.descTxt = UICreate.createLabel(self.content, "", -150, 0, 309, 30, 24);
	self.descTxt.spacingY = 6;
	self.descTxt.pivot =  UIWidget.Pivot.TopLeft;
	self.descTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.descTxt.clickScale = false;
	self.descTxt:setDepth(2);
end

function Lua_TreasureRecordsItem:getHeight()
	return self.descTxt.height + 10;
end

function Lua_TreasureRecordsItem:setData(data)
	self._data = data.data;

	if data.data ~= nil then
		self.vo = Lua_ToolVo.createToolVo(data.data.proto_item.id);
		self.vo:fromServer(data.data.proto_item);
		self.vo.packType = Lua_PackTypeDefine.EQUIP;

		local str;
		local nameStr;
		local drawType = data.drawType;
		if self.vo ~= nil then
			str = "[url=showItem_"..data.data.proto_item.id.."]"..self.vo.colorName.."[/url]";
			nameStr = "[url=playerClick_"..data.data.role_id.."]"..data.data.role_name.."[/url]";
			if drawType == DataCenter.treasureData.equipmentDrawType then
				self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(121404), nameStr, str);
			elseif drawType == DataCenter.treasureData.peakDrawType then
				self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(121436), nameStr, str);
			elseif drawType == DataCenter.treasureData.supremacyDrawType then
				self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(121441), nameStr, str);
			elseif drawType == DataCenter.treasureData.apotheosizeDrawType then
				self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(121447), nameStr, str);
			end
		end
	end
end

function Lua_TreasureRecordsItem:onPlayerSoundClick()
	local urlStr = self.descTxt:getUrlByMousePos();
	if urlStr ~= nil then
		local arr = string.split(urlStr, "_");
		if arr[1] == "showItem" then
			Lua_PackUtil.showItemInfo(self.vo);
		elseif arr[1] == "playerClick" then
			Lua_ChatUtil.playerMenuPopListShow(self._data);
		end
	end
end

function Lua_TreasureRecordsItem:onClickDescTxt(go)
	if self.vo ~= nil then
		Lua_PackUtil.showItemInfo(self.vo);
	end
end

function Lua_TreasureRecordsItem:dispose()
	if self.descTxt ~= nil then
		self.descTxt:dispose();
		self.descTxt = nil;
	end
	self.vo = nil;

	self:superCall("dispose");
end