-- 灵纹抽奖结算界面
checkRequire("Lua_TreasureResultWindow");
Lua_RunesTreasureResultWindow = class("Lua_RunesTreasureResultWindow", Lua_TreasureResultWindow);
function Lua_RunesTreasureResultWindow:ctor()
    self:superCall("ctor");
    self.bShowRuneChips = true;
    self.bShowRuneCrystal = true;
    self.needShowIconBg = false;
    self.itemWidth = 130;
    self.windowName = "Lua_RunesTreasureResultWindow";
end

function Lua_RunesTreasureResultWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self:addLuaEvent("rTreasureRunesDraw", self, self.onTreasureRunesDraw);
end

function Lua_RunesTreasureResultWindow:onTreasureRunesDraw(msg)
    self.drawType = msg.draw_type; -- 抽奖类型 0一次 1十次
    if self.drawType == 1 then -- 十次
        self.againBtn.label = LanUtil.getValue(121433);
    else
        self.againBtn.label = LanUtil.getValue(121409);
    end
    local num = msg.frag_count - DataCenter.treasureData.runeChipsNum;  -- 获得的灵纹碎片
    local list = msg.item_list; -- 获得的道具列表
    local len = #list;
    local arr = Array();
    for i = 1, len do
        if tonumber(list[i].id) ~= 201060101 then
            local to = Lua_ToolVo.new(list[i].id);
            to:fromServer(list[i]);
            to.bShowQualityEff = true;
            arr:add(to);
        end
    end
    self:setShowResultData(arr, num);
    for i = 1, self.rewardsArr:getSize() do
        self.rewardsArr[i].itemName.pivot = UIWidget.Pivot.Top;
        self.rewardsArr[i].itemName.overflowMethod = UILabel.Overflow.ResizeHeight;
        self.rewardsArr[i].itemName:SetDimensions(122, 30);
        self.rewardsArr[i].itemName:setLocation(0, -50);
    end
end

function Lua_RunesTreasureResultWindow:onAgainBtnClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.show(LanUtil.getValue(121419));
        return;
    end
    self.clickTime = getTime();
    if self.drawType == nil then
        self:hide();
        return;
    end

    local costId = DataCenter.treasureUtil.runeDrawCostId;
    local ownNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(costId);
    local costNum = self.drawType == 1 and DataCenter.treasureUtil.runeDrawTenCostNum or DataCenter.treasureUtil.runeDrawOneCostNum;
    local needBuyNum = costNum - ownNum;
    if needBuyNum > 0 then
        local vo = Lua_ToolVo.new(costId);
        if vo ~= nil then
            local str = "";
            self.costGoldNum = vo.goldPrice * needBuyNum;
            if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.costGoldNum then
                str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(self.costGoldNum).."[-]";
                self.bEnoughGold = false;
            else
                str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(self.costGoldNum).."[-]";
                self.bEnoughGold = true;
            end

            if DataCenter.neverTip:getNeverValue("Lua_RunesTreasurePanel") == true then
                if self.bEnoughGold == false then
                    OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121427), vo.colorName));
                else
                    Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureRunesDraw(self.drawType);
                end
                return;
            end

            local tipData = {};
            tipData.des = LanUtil.formateStr(LanUtil.getValue(121426), vo.colorName, str, tostring(needBuyNum));  
            tipData.neverTip = "Lua_RunesTreasurePanel";
            tipData.owner = self;
            tipData.type = 1;
            tipData.subFun = self.onSureFun;   --确定
            Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
        end
    else
        Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureRunesDraw(self.drawType);
    end
    self:superCall("onAgainBtnClick", go);
end

function Lua_RunesTreasureResultWindow:onSureFun()
    if self.bEnoughGold == true then
        Lua_ProxyManager.getProxy("Lua_TreasureProxy"):sTreasureRunesDraw(self.drawType);
    else
        DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, self.costGoldNum, true, true);
    end
end

function Lua_RunesTreasureResultWindow:dispose()
    self:superCall("dispose");  
end